const express = require('express')
const path = require('path')
const http = require('http')
const bodyParser = require('body-parser')
const app = express()
const port = process.env.port || 3999

/**
 * Log is a property of the global object,
 * so the dependency on Log should be in front of other dependencies
 */
require('./lib/log.js')

const router = require('./routers/')

app.use(bodyParser.json())
app.use(bodyParser.urlencoded({ extended: false }))
app.use(express.static(path.join(__dirname, 'public')))

//cors
app.use( (req, res, next) => {
  res.header('Access-Control-Allow-Origin', '*')
  res.header('Access-Control-Allow-Headers', 'Content-Type')
  res.header('Access-Control-Allow-Credentials', true)
  req.header('Access-Control-Max-Age', 600)
  if (req.method === 'OPTIONS') return res.end()
  return next()
})

//request log
app.use( (req, res, next) => {
  Log.data('todo access log')
  return next()
})

app.use(router)

app.set('etag', false)

http.createServer(app).listen(port, function () {
  Log.data('jj-proxy server start', {port: port})
})
